import component from 'kompo';
var construct = component.construct;


import { addClasses, create } from 'kompo-util';

export default construct('a', function (_ref) {
    var _this = this;

    var defaultClass = _ref.defaultClass,
        classes = _ref.classes,
        checked = _ref.checked,
        callback = _ref.callback,
        label = _ref.label;

    this.href = '#';
    this.classList.add(defaultClass);
    addClasses(this, classes);

    var props = this.kompo.props;

    this.textContent = label;

    setCheck(this, checked);

    this.addEventListener('click', function (e) {
        e.preventDefault();
        toggle(props, _this);
        if (callback) callback(e, props.checked);
    });
}, {
    defaultClass: 'o-Check',
    classes: [],
    checked: false,
    checkedClass: 'o-Check--checked',
    callback: undefined,
    label: ''
});

function toggle(props, el) {
    if (props.checked) {
        el.classList.remove(props.checkedClass);
        props.checked = false;
    } else {
        el.classList.add(props.checkedClass);
        props.checked = true;
    }
}

export function setCheck(check, b) {
    var props = check.kompo.props;

    if (b === true) {
        check.classList.add(props.checkedClass);
        props.checked = true;
    } else {
        check.classList.remove(props.checkedClass);
        props.checked = false;
    }
}

export function isChecked(check) {
    return check.kompo.props.checked;
}