import component from 'kompo';
var construct = component.construct;


import { addClasses, create } from 'kompo-util';

export default construct('div', function (_ref) {
    var _this = this;

    var defaultClass = _ref.defaultClass,
        classes = _ref.classes,
        defaultOptionIndex = _ref.defaultOptionIndex,
        options = _ref.options,
        optionClass = _ref.optionClass,
        callback = _ref.callback;

    this.classList.add(defaultClass);
    addClasses(this, classes);

    var props = this.kompo.props,
        keys = Object.keys(options);

    var _loop = function _loop(i, l) {
        var key = keys[i],
            value = options[key],
            a = create('a', { 'class': optionClass, href: '#' + key });

        a.textContent = value;

        if (defaultOptionIndex === i) {
            setSelected(props, a, key, value);
        }

        a.addEventListener('click', function (e) {
            e.preventDefault();

            if (props.selected === a) return;

            setSelected(props, a, key, value);
            if (callback) callback(e, key, value);
        });

        props.optionElements.push(a);

        _this.appendChild(a);
    };

    for (var i = 0, l = keys.length; i < l; ++i) {
        _loop(i, l);
    }
}, {
    defaultClass: 'o-Radio',
    classes: [],
    defaultOptionIndex: undefined,
    optionClass: 'o-Radio-option',
    selectedOptionClass: 'o-Radio-option--selected',
    options: {},
    optionElements: [],
    selected: undefined,
    selectedKey: undefined,
    selectedValue: undefined,
    callback: undefined
});

function setSelected(props, el, key, value) {
    if (props.selected) props.selected.classList.remove(props.selectedOptionClass);
    el.classList.add(props.selectedOptionClass);
    props.selected = el;
    props.selectedKey = key;
    props.selectedValue = value;
}

export function setOption(option, k) {
    var props = option.kompo.props,
        els = props.optionElements;

    for (var i = 0, l = els.length; i < l; ++i) {
        var el = els[i];

        if (el.href.indexOf('#' + k) !== -1) {
            setSelected(props, el, k, el.textContent);
        }
    }
}

export function getKey(radio) {
    return radio.kompo.props.selectedKey;
}

export function getValue(radio) {
    return radio.kompo.props.selectedValue;
}