import constructMultipanel, { slideTo, slide } from './multiPanel/multiPanel';
import panel from './multiPanel/panel';

import constructTable, { tableActions } from './table/table';
import accordionTable from './table/accordionTable';
import selectTable from './table/selectTable';
import infiniteTable, { resetSpacers, multiSelect } from './table/infiniteTable';

import datePicker, { outputSelectedDate, isolatedReact, setSelectedDate, clear } from './date/datePicker';
import dateRange, { setSelectedDates, clearDateRange } from './date/dateRange';

import constructAutocomplete, { reset as empty } from './autocomplete/autocomplete';

import constructTab, { Tab } from './tab/tab';

import constructRadio, { getKey, getValue, setOption } from './form/radio';
import constructCheck, { isChecked, setCheck } from './form/check';

import constructOrderList from './orderList/orderList';

var multiPanel = {
    constructMultipanel: constructMultipanel,
    slideTo: slideTo,
    slide: slide,
    panel: panel
};

var table = {
    constructTable: constructTable,
    tableActions: tableActions,
    accordionTable: accordionTable,
    selectTable: selectTable,
    infiniteTable: infiniteTable,
    resetSpacers: resetSpacers,
    multiSelect: multiSelect
};

var date = {
    datePicker: datePicker,
    outputSelectedDate: outputSelectedDate,
    setSelectedDate: setSelectedDate,
    isolatedReact: isolatedReact,
    clear: clear,
    dateRange: dateRange,
    setSelectedDates: setSelectedDates,
    clearDateRange: clearDateRange
};

var autocomplete = {
    constructAutocomplete: constructAutocomplete,
    empty: empty
};

var tab = {
    constructTab: constructTab,
    Tab: Tab
};

var radio = {
    constructRadio: constructRadio,
    getKey: getKey,
    getValue: getValue,
    setOption: setOption
};

var check = {
    constructCheck: constructCheck,
    isChecked: isChecked,
    setCheck: setCheck
};

var orderList = {
    constructOrderList: constructOrderList
};

export { multiPanel, table, date, autocomplete, tab, radio, check, orderList };