import component, { state } from 'kompo';
var dispatch = state.dispatch;
var mount = component.mount,
    getRouter = component.getRouter;


import { create, isObject } from 'kompo-util';

import getDynamicWidth from '../utils/getDynamicWidth';

export default component.construct('div', function (_ref) {
    var _classList,
        _this = this;

    var classNames = _ref.classNames,
        basis = _ref.basis,
        unit = _ref.unit,
        component = _ref.component,
        overlay = _ref.overlay,
        index = _ref.index,
        slideTo = _ref.slideTo,
        slideToUrl = _ref.slideToUrl,
        slideBack = _ref.slideBack,
        multiPanelProps = _ref.multiPanelProps;

    var percentage = isObject(basis) ? getDynamicWidth(basis) / 100 * multiPanelProps.totalWidthPercentage : basis / 100 * multiPanelProps.totalWidthPercentage,
        pu = percentage + unit;

    classNames.push('o-MultiPanel-panel');
    (_classList = this.classList).add.apply(_classList, classNames);
    this.style.width = pu;

    if (overlay) {
        var o = create('div', { 'class': 'o-MultiPanel-panel-overlay' });
        this.appendChild(o);
        o.addEventListener('click', function (e) {
            if (slideBack) {
                history.back();
            } else if (slideToUrl) {
                dispatch(_this, function (state) {
                    state.url = slideToUrl();
                });
            } else if (typeof index !== 'undefined' && slideTo) {
                slideTo(index);
            }
        });
    }

    // Pass on level to component for further routing
    component.kompo.level = this.kompo.level;

    mount(this, component, this.kompo.selector);
    this.appendChild(component);
}, {
    classNames: [],
    basis: 100,
    unit: '%',
    component: undefined,
    overlay: true,
    index: undefined,
    slideTo: undefined,
    slideToUrl: undefined,
    multiPanelProps: undefined,
    slideBack: false
});