import component, { state } from 'kompo';
var construct = component.construct,
    react = component.react,
    mount = component.mount,
    unmountAll = component.unmountAll,
    getState = component.getState;
var dispatch = state.dispatch,
    markDirty = state.markDirty;


import { create, createFragment, empty } from 'kompo-util';

import '../../css/orderRow.css';

export default construct('div', function (_ref) {
    var _classList,
        _this = this;

    var defaultClass = _ref.defaultClass,
        classes = _ref.classes;

    classes.push(defaultClass);
    (_classList = this.classList).add.apply(_classList, classes);

    react(this, function (state) {
        console.log(state);
        if (!state || !Array.isArray(state)) return;

        empty(_this); // Always reset
        var frag = createFragment();

        for (var i = 0, l = state.length; i < l; ++i) {
            var row = state[i],
                rowElement = create('div', { 'class': 'o-OrderRow-row' });

            for (var ri = 0, rl = row.length; ri < rl; ++ri) {
                var columnElement = create('div', { 'class': 'o-OrderRow-column' });

                columnElement.textContent = i + '.' + ri;
                rowElement.appendChild(columnElement);
            }

            frag.appendChild(rowElement);
        }

        _this.appendChild(frag);
    });
}, {
    defaultClass: 'o-OrderRow',
    classes: []
});