var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

import component from 'kompo';
var construct = component.construct,
    mount = component.mount;


import { addClasses, create } from 'kompo-util';

export default construct('div', function (_ref) {
    var _this = this;

    var defaultClass = _ref.defaultClass,
        classes = _ref.classes,
        tabs = _ref.tabs,
        defaultTabIndex = _ref.defaultTabIndex,
        tabWrapperClass = _ref.tabWrapperClass,
        tabClass = _ref.tabClass,
        contentWrapperClass = _ref.contentWrapperClass,
        contentClass = _ref.contentClass,
        selectedTabClass = _ref.selectedTabClass,
        selectedContentClass = _ref.selectedContentClass;

    this.classList.add(defaultClass);
    addClasses(this, classes);

    var tabWrapper = create('div', { 'class': tabWrapperClass }),
        contentWrapper = create('div', { 'class': contentWrapperClass });
    this.appendChild(tabWrapper);
    this.appendChild(contentWrapper);

    var selectedTab = void 0,
        selectedContent = void 0;

    var _loop = function _loop(i, l) {
        var ti = tabs[i],
            t = create('a', { 'class': tabClass, href: '#' + ti.getName() }),
            c = create('div', { 'class': contentClass });

        t.textContent = ti.getHumanName();
        tabWrapper.appendChild(t);

        if (defaultTabIndex === i) {
            t.classList.add(selectedTabClass);
            selectedTab = t;
            c.classList.add(selectedContentClass);
            selectedContent = c;
        }

        t.addEventListener('click', function (e) {
            e.preventDefault();

            if (selectedTab === t) return;

            if (selectedTab) selectedTab.classList.remove(selectedTabClass);
            t.classList.add(selectedTabClass);
            selectedTab = t;

            if (selectedContent) selectedContent.classList.remove(selectedContentClass);
            c.classList.add(selectedContentClass);
            selectedContent = c;
        });

        // Append different types of content to append
        append(_this, c, ti.getContent());
        contentWrapper.appendChild(c);
    };

    for (var i = 0, l = tabs.length; i < l; ++i) {
        _loop(i, l);
    }
}, {
    defaultClass: 'o-Tab',
    classes: [],
    tabs: [],
    defaultTabIndex: 0,
    tabWrapperClass: 'o-Tab-tabWrapper',
    tabClass: 'o-Tab-tab',
    contentWrapperClass: 'o-Tab-contentWrapper',
    contentClass: 'o-Tab-content',
    selectedTabClass: 'o-Tab-tab--selected',
    selectedContentClass: 'o-Tab-content--selected'
});

function append(component, parent, child) {
    if (Array.isArray(child)) {
        for (var i = 0, l = child.length; i < l; ++i) {
            _append(component, parent, child[i]);
        }

        return;
    }

    _append(component, parent, child);
}

function _append(component, parent, child) {
    if (typeof child === 'string') {
        parent.textContent = child;
    } else if (child.hasOwnProperty('kompo')) {
        mount(component, child, component.kompo.selector);
        parent.appendChild(child);
    } else if (child instanceof Node) {
        parent.appendChild(child);
    } else {
        throw new Error('Child should be a string, KompoElement or a Node');
    }
}

export var Tab = function () {
    function Tab(options) {
        _classCallCheck(this, Tab);

        this.options = _extends({
            name: '',
            humanName: '',
            content: undefined
        }, options);
    }

    Tab.prototype.getName = function getName() {
        return this.options.name;
    };

    Tab.prototype.getHumanName = function getHumanName() {
        return this.options.humanName ? this.options.humanName : this.options.name;
    };

    Tab.prototype.getContent = function getContent() {
        return this.options.content;
    };

    return Tab;
}();