import component, { state } from 'kompo';
import { empty } from 'kompo-util';

export default component.construct('tr', function (_ref) {
    var _this = this;

    var defaultClass = _ref.defaultClass,
        selectedClass = _ref.selectedClass,
        hasColumnFilter = _ref.hasColumnFilter,
        columnFilter = _ref.columnFilter;


    if (defaultClass) this.classList.add(defaultClass);

    component.react(this, function (s) {
        if (selectedClass) {
            if (s.__kompo_selected__) {
                _this.classList.add(selectedClass);
            } else {
                _this.classList.remove(selectedClass);
            }
        }

        empty(_this);
        var data = hasColumnFilter ? columnFilter(s) : s,
            keys = Object.keys(data);
        for (var i = 0, l = keys.length; i < l; ++i) {
            var k = keys[i],
                v = data[k];

            // if(typeof minimizeWhitelist !== 'undefined') {
            //     const onWhitelist = isObject?
            //     minimizeWhitelist.indexOf(k) === -1:
            //     minimizeWhitelist.indexOf(filtered[k]) === -1;
            //     if(minimize && onWhitelist) {
            //         continue;
            //     }
            // }

            var c = _this.appendChild(document.createElement('td'));
            if (v instanceof Node) {
                c.appendChild(v);
            } else {
                c.textContent = v;
            }
        }
    });
}, {
    defaultClass: ''
});